#include <stdio.h>
#define min(x,y)  (x < y ? x : y)

/*----------------------------------------------------------------*/
/* get_coords() -- Breaks node down into its respective dimension */
/*                 coordinates.                                   */
/*----------------------------------------------------------------*/
get_coords (src, n)
     int src, n[16];
{
  register int j, nd;
 
  nd = src;
  for (j = 0; j < 2; j++)
    {
      n[j] = nd % 16;
      nd = (nd >> 4);
    }
}

/*---------------------------------------------------------------*/
/* get_addr() -- Converts back from coords to addresses          */
/*---------------------------------------------------------------*/
get_addr (n)
     int n[16];
{
  int nd;
 
  nd = n[0] + n[1]*16 ;
  return nd;
}

/*-----------------------------------------------------------*/
/* Bit reversal                                              */
/*-----------------------------------------------------------*/

int bit_reversal (i)
     int i;
{
  int j, k, bit;

  k = 0;
  for (j = 0; j < 8; j++)
    {
      bit = i % 2;
      i = i / 2;
      k = k * 2;
      k |= bit;
    }
  return k;
}

/*-----------------------------------------------------------*/
/* Transpose                                                 */
/*-----------------------------------------------------------*/

int transpose (i)
     int i;
{
  int j, k, t1[16], t2[16];
  
  get_coords (i, t1);
  for (j = 0; j < 1; j += 2)
    {
      t2[j] = t1[j + 1];
      t2[j + 1] = t1[j];
    }
  if (j < 2)
    t2[j] = t1[j];
  k = get_addr (t2);
  return k;
}

/*---------------------------------------------------------------*/
/* distance()  Calculate the minimum distance between two nodes. */
/*---------------------------------------------------------------*/

distance (n1, n2)
     int n1, n2;
{
  int j, sum, diff, t1[16], t2[16];
  
  get_coords (n1, t1);
  get_coords (n2, t2);
  sum = 0;
  for (j = 0; j < 2; j++)
    {
      if (t1[j] != t2[j])
	{
	  diff = abs (t1[j] - t2[j]);
	  sum += min (abs (16 - diff), diff);
	}
    }
  return sum;
}

main()
{
  int i, src, dest, dist0=0, dist1=0, dist2=0, dist3=0, dist4=0, dist5=0, dist6=0, dist7=0, dist8=0, dist9=0, dist10=0, dist11=0, dist12=0, dist13=0, dist14=0, dist15=0, dist16=0, min_dist;

  for (i = 0; i < 256; i++)
    {
      src = i;
      dest = bit_reversal (i);
      printf("source = %i, destination = %i\n",src,dest);
      min_dist = distance (src, dest);
      printf("Distance = %i\n",min_dist);

      if (min_dist == 0) dist0 ++;      
      if (min_dist == 1) dist1 ++;
      if (min_dist == 2) dist2 ++;
      if (min_dist == 3) dist3 ++;
      if (min_dist == 4) dist4 ++;
      if (min_dist == 5) dist5 ++;
      if (min_dist == 6) dist6 ++;
      if (min_dist == 7) dist7 ++;
      if (min_dist == 8) dist8 ++;
      if (min_dist == 9) dist9 ++;
      if (min_dist == 10) dist10 ++;
      if (min_dist == 11) dist11++;
      if (min_dist == 12) dist12++;
      if (min_dist == 13) dist13++;
      if (min_dist == 14) dist14++;
      if (min_dist == 15) dist15++;
      if (min_dist == 16) dist16++;
    }

  printf("Results for bit_reversal\n");

  printf("%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i\n", dist0, dist1, dist2, dist3, dist4, dist5, dist6, dist7, dist8, dist9, dist10, dist11, dist12,dist13, dist14, dist15, dist16);

  dist0=0; 
  dist1=0; 
  dist2=0; 
  dist3=0; 
  dist4=0; 
  dist5=0; 
  dist6=0; 
  dist7=0; 
  dist8=0; 
  dist9=0; 
  dist10=0; 
  dist11=0; 
  dist12=0; 
  dist13=0; 
  dist14=0; 
  dist15=0; 
  dist16=0;
  
  for (i = 0; i < 256; i++)
    {
      src = i;
      dest = transpose (i);
      printf("source = %i, destination = %i\n",src,dest);
      min_dist = distance (src, dest);
      printf("Distance = %i\n",min_dist);

      if (min_dist == 0) dist0 ++;
      if (min_dist == 1) dist1 ++;
      if (min_dist == 2) dist2 ++;
      if (min_dist == 3) dist3 ++;
      if (min_dist == 4) dist4 ++;
      if (min_dist == 5) dist5 ++;
      if (min_dist == 6) dist6 ++;
      if (min_dist == 7) dist7 ++;
      if (min_dist == 8) dist8 ++;
      if (min_dist == 9) dist9 ++;
      if (min_dist == 10) dist10 ++;
      if (min_dist == 11) dist11++;
      if (min_dist == 12) dist12++;
      if (min_dist == 13) dist13++;
      if (min_dist == 14) dist14++;
      if (min_dist == 15) dist15++;
      if (min_dist == 16) dist16++;
    }

  printf("Results for transpose\n");
 
  printf("%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i\n", dist0, dist1,
dist2, dist3, dist4, dist5, dist6, dist7, dist8, dist9, dist10, dist11, dist12,
dist13, dist14, dist15, dist16);

}



 
